// Written by TeTeT
// add fire effect when flamethrower hits an object

ft addEventHandler ["fired", { _this spawn uns_fnc_igniteFire;}];

uns_fnc_igniteFire = {
	params ["_unit", "_weapon", "_muzzle", "_mode", "_ammo", "_magazine", "_projectile"];

	// systemChat format["_weapon is %1", _weapon];
	if (toLower(_weapon) in ["uns_m10_8_flamethrower"]) then {
		// systemChat "Flame on";
		private _pos = getPosATL _projectile;
		while {!isNull _projectile} do {
			// systemChat "Updating pos";
			_pos = getPosATL _projectile;
			sleep 0.05;
		};
		// systemChat format ["pos is %1", _pos];
		private _objects = lineIntersectsObjs [ATLtoASL _pos, getPosASL _unit, objNull, _unit, false, 4];
		// systemChat str _objects;
		if (count _objects > 0) then {
 			private _fire = createVehicle ["test_EmptyObjectForFireBig", _pos, [], 0, "CAN_COLLIDE"];
 			// 60 seconds burn time for a start
 			private _t = time + 60;
 			private _fires = _unit getVariable ["uns_fires", []];
 			_fires pushBack [_t, _fire];
 			_unit setVariable ["uns_fires", _fires, false];
		};
	};
};

/**
 * TeTeT: this does not extinguish the fire :(
 **/
[] spawn {
	ft setVariable ["uns_fires", [], false];
	while {alive ft} do {
		sleep 10;

		private _newFires = [];
		{	
			// systemChat format["fire is %1", _x];
			if (_x select 0 < time) then {
				{
					// systemChat str (typeOf _x);
					if (typeOf _x in ["#particlesource", "#lightpoint"]) then {
						deleteVehicle _x;
					};
				} forEach (nearestObjects [_x select 1, [], 5]);
				deleteVehicle (_x select 1);
			} else {
				_newFires pushBack _x;
			};
		} forEach (ft getVariable ["uns_fires", []]);
		ft setVariable ["uns_fires", _newFires, false];
	};
};
